/*	-----------------------------------------------------------------------------
	M A A S C R A F T

	StarCraft: Brood War - Bot

	Author: Dennis Soemers
	Maastricht University
	-----------------------------------------------------------------------------
*/

#pragma once

#include "Options.h"

#include <string>
#include <sstream>

#ifdef MAASCRAFT_DEBUG

class StringBuilder
{
public:
    template<typename T>
    StringBuilder &operator <<(const T &value)
    {
        builder << value;

        return (*this);
    }

    operator std::string()
    {
        return (builder.str());
    }

	std::string getString()
	{
		return (builder.str());
	}

private:
    std::ostringstream builder; 
};
#else
class StringBuilder
{
public:
	template<typename T>
    StringBuilder &operator <<(const T &value)
    {
        return (*this);
    }

    operator std::string()
    {
        return ("");
    }

	std::string getString()
	{
		return ("");
	}
};

#endif // MAASCRAFT_DEBUG